DEV: clean up docker detection
[discourse_docker.git] / launcher
CommitLineData
ace450bd 1#!/bin/bash
7e738616 2
5cb39519 3usage () {
c2d3ee4a 4 echo "Usage: launcher COMMAND CONFIG [--skip-prereqs] [--docker-args STRING]"
5cb39519 5 echo "Commands:"
1ec142a1
GXT
6 echo " start: Start/initialize a container"
7 echo " stop: Stop a running container"
8 echo " restart: Restart a container"
9 echo " destroy: Stop and remove a container"
10 echo " enter: Open a shell to run commands inside the container"
11 echo " logs: View the Docker logs for a container"
12 echo " bootstrap: Bootstrap a container for the config based on a template"
2791af60 13 echo " run: Run the given command with the config in the context of the last bootstrapped image"
1ec142a1
GXT
14 echo " rebuild: Rebuild a container (destroy old, bootstrap, start new)"
15 echo " cleanup: Remove all containers that have stopped for > 24 hours"
5cb39519
JA
16 echo
17 echo "Options:"
1f656469 18 echo " --skip-prereqs Don't check launcher prerequisites"
1f656469 19 echo " --docker-args Extra arguments to pass when running docker"
cad2919f 20 echo " --skip-mac-address Don't assign a mac address"
c786ffcd 21 echo " --run-image Override the image used for running the container"
5cb39519
JA
22 exit 1
23}
24
7e738616
S
25command=$1
26config=$2
65573a0e 27user_args=""
c786ffcd 28user_run_image=""
87c4f221 29
1ec142a1
GXT
30if [[ $command == "run" ]]; then
31 run_command=$3
32fi
33
1f656469 34while [ ${#} -gt 0 ]; do
65573a0e 35 case "${1}" in
19e3a6c0
S
36 --debug)
37 DEBUG="1"
38 ;;
1f656469 39 --skip-prereqs)
4f36bb43 40 SKIP_PREREQS="1"
1f656469 41 ;;
cad2919f
GXT
42 --skip-mac-address)
43 SKIP_MAC_ADDRESS="1"
44 ;;
1f656469
GXT
45 --docker-args)
46 user_args="$2"
47 shift
48 ;;
c786ffcd
GXT
49 --run-image)
50 user_run_image="$2"
51 shift
52 ;;
1f656469
GXT
53 esac
54
55 shift 1
56done
55d17203 57
ea4428d7 58if [ -z "$command" -o -z "$config" -a "$command" != "cleanup" ]; then
f80e6a37
GXT
59 usage
60 exit 1
61fi
62
87756d6d 63# Docker doesn't like uppercase characters, spaces or special characters, catch it now before we build everything out and then find out
abcf2a97 64re='[[:upper:]/ !@#$%^&*()+~`=]'
87756d6d
EH
65if [[ $config =~ $re ]];
66 then
8877f99e 67 echo
abcf2a97 68 echo "ERROR: Config name '$config' must not contain upper case characters, spaces or special characters. Correct config name and rerun $0."
87756d6d
EH
69 echo
70 exit 1
71fi
72
7936ebaa 73cd "$(dirname "$0")"
55d17203 74
0998a7c8 75docker_min_version='17.03.1'
ddf8c54c 76docker_rec_version='17.06.2'
6828238a
JP
77git_min_version='1.8.0'
78git_rec_version='1.8.0'
60668406 79
8dea575c 80config_file=containers/"$config".yml
5201a40c 81cidbootstrap=cids/"$config"_bootstrap.cid
5efded6a 82local_discourse=local_discourse
11fa21bc 83image=discourse/base:2.0.20190217
9eeb324e 84docker_path=`which docker.io 2> /dev/null || which docker`
6828238a 85git_path=`which git`
8877f99e 86
e0fd1f5b
TB
87if [ "${SUPERVISED}" = "true" ]; then
88 restart_policy="--restart=no"
89 attach_on_start="-a"
90 attach_on_run="-a stdout -a stderr"
91else
92 attach_on_run="-d"
93fi
94
f2a3edee
AY
95if [ -n "$DOCKER_HOST" ]; then
96 docker_ip=`sed -e 's/^tcp:\/\/\(.*\):.*$/\1/' <<< "$DOCKER_HOST"`
97elif [ -x "$(which ip 2>/dev/null)" ]; then
813fef38 98 docker_ip=`ip addr show docker0 | \
03bb0735
LG
99 grep 'inet ' | \
100 awk '{ split($2,a,"/"); print a[1] }';`
101else
813fef38 102 docker_ip=`ifconfig | \
03bb0735
LG
103 grep -B1 "inet addr" | \
104 awk '{ if ( $1 == "inet" ) { print $2 } else if ( $2 == "Link" ) { printf "%s:" ,$1 } }' | \
105 grep docker0 | \
106 awk -F: '{ print $3 }';`
107fi
80c11be3 108
7a96c86d 109# From https://stackoverflow.com/a/44660519/702738
60668406 110compare_version() {
7a96c86d
RSS
111 if [[ $1 == $2 ]]; then
112 return 1
113 fi
114 local IFS=.
115 local i a=(${1%%[^0-9.]*}) b=(${2%%[^0-9.]*})
116 local arem=${1#${1%%[^0-9.]*}} brem=${2#${2%%[^0-9.]*}}
117 for ((i=0; i<${#a[@]} || i<${#b[@]}; i++)); do
118 if ((10#${a[i]:-0} < 10#${b[i]:-0})); then
60668406 119 return 1
7a96c86d
RSS
120 elif ((10#${a[i]:-0} > 10#${b[i]:-0})); then
121 return 0
60668406
DP
122 fi
123 done
7a96c86d
RSS
124 if [ "$arem" '<' "$brem" ]; then
125 return 1
126 elif [ "$arem" '>' "$brem" ]; then
127 return 0
128 fi
129 return 1
60668406
DP
130}
131
665468eb
JA
132
133install_docker() {
c2d3ee4a 134 echo "Docker is not installed, you will need to install Docker in order to run Launcher"
bf6d49b5 135 echo "See https://docs.docker.com/installation/"
665468eb
JA
136 exit 1
137}
138
87c4f221 139check_prereqs() {
794e44d5
GXT
140
141 if [ -z $docker_path ]; then
665468eb
JA
142 install_docker
143 fi
a3e18d95 144
e741295a 145 # 1. docker daemon running?
30835a52
S
146 # we send stderr to /dev/null cause we don't care about warnings,
147 # it usually complains about swap which does not matter
148 test=`$docker_path info 2> /dev/null`
e741295a
MB
149 if [[ $? -ne 0 ]] ; then
150 echo "Cannot connect to the docker daemon - verify it is running and you have access"
151 exit 1
152 fi
153
90287f8e 154 # 2. running an approved storage driver?
7644adb7 155 if ! $docker_path info 2> /dev/null | egrep -q '^Storage Driver: (aufs|btrfs|zfs|overlay|overlay2)$'; then
90287f8e 156 echo "Your Docker installation is not using a supported storage driver. If we were to proceed you may have a broken install."
7644adb7 157 echo "aufs is the recommended storage driver, although zfs/btrfs/overlay and overlay2 may work as well."
90287f8e
MP
158 echo "Other storage drivers are known to be problematic."
159 echo "You can tell what filesystem you are using by running \"docker info\" and looking at the 'Storage Driver' line."
5dfdf9a3 160 echo
90287f8e
MP
161 echo "If you wish to continue anyway using your existing unsupported storage driver,"
162 echo "read the source code of launcher and figure out how to bypass this check."
48f22d14 163 exit 1
a3e18d95
S
164 fi
165
60668406
DP
166 # 3. running recommended docker version
167 test=($($docker_path --version)) # Get docker version string
168 test=${test[2]//,/} # Get version alone and strip comma if exists
a3e18d95 169
87c4f221 170 # At least minimum docker version
cf00fce0 171 if compare_version "${docker_min_version}" "${test}"; then
60668406 172 echo "ERROR: Docker version ${test} not supported, please upgrade to at least ${docker_min_version}, or recommended ${docker_rec_version}"
a3e18d95
S
173 exit 1
174 fi
175
87c4f221 176 # Recommend newer docker version
60668406
DP
177 if compare_version "${docker_rec_version}" "${test}"; then
178 echo "WARNING: Docker version ${test} deprecated, recommend upgrade to ${docker_rec_version} or newer."
179 fi
180
405948ee
S
181 # 4. discourse docker image is downloaded
182 test=`$docker_path images | awk '{print $1 ":" $2 }' | grep "$image"`
183
184 if [ -z "$test" ]; then
185 echo
186 echo "WARNING: We are about to start downloading the Discourse base image"
187 echo "This process may take anywhere between a few minutes to an hour, depending on your network speed"
188 echo
189 echo "Please be patient"
190 echo
405948ee 191 fi
405948ee 192
6828238a
JP
193 # 5. running recommended git version
194 test=($($git_path --version)) # Get git version string
195 test=${test[2]//,/} # Get version alone and strip comma if exists
196
197 # At least minimum version
198 if compare_version "${git_min_version}" "${test}"; then
199 echo "ERROR: Git version ${test} not supported, please upgrade to at least ${git_min_version}, or recommended ${git_rec_version}"
200 exit 1
201 fi
202
203 # Recommend best version
204 if compare_version "${git_rec_version}" "${test}"; then
205 echo "WARNING: Git version ${test} deprecated, recommend upgrade to ${git_rec_version} or newer."
206 fi
207
208 # 6. able to attach stderr / out / tty
e02c1511 209 test=`$docker_path run $user_args -i --rm -a stdout -a stderr $image echo working`
a3e18d95
S
210 if [[ "$test" =~ "working" ]] ; then : ; else
211 echo "Your Docker installation is not working correctly"
212 echo
213 echo "See: https://meta.discourse.org/t/docker-error-on-bootstrap/13657/18?u=sam"
214 exit 1
215 fi
4770834b 216
49b2fcc4 217 # 7. enough space for the bootstrap on docker folder
8cdc533d
RSS
218 folder=`$docker_path info --format '{{.DockerRootDir}}'`
219 safe_folder=${folder:-/var/lib/docker}
49b2fcc4
RSS
220 test=$(($(stat -f --format="%a*%S" $safe_folder)/1024**3 < 5))
221 if [[ $test -ne 0 ]] ; then
da095c30
RSS
222 echo "You have less than 5GB of free space on the disk where $safe_folder is located. You will need more space to continue"
223 df -h $safe_folder
49b2fcc4
RSS
224 echo
225 read -p "Would you like to attempt to recover space by cleaning docker images and containers in the system?(y/N)" -n 1 -r
226 echo
227 if [[ $REPLY =~ ^[Yy]$ ]]
228 then
3273a8e1 229 $docker_path system prune -af
49b2fcc4
RSS
230 echo "If the cleanup was successful, you may try again now"
231 fi
232 exit 1
233 fi
6e784be6
MP
234}
235
6828238a 236
cf3dd6f2 237if [ -z "$SKIP_PREREQS" ] && [ "$command" != "cleanup" ]; then
87c4f221 238 check_prereqs
55d17203 239fi
a3e18d95 240
60f9f04c
S
241host_run() {
242 read -r -d '' env_ruby << 'RUBY'
243 require 'yaml'
244
245 input = STDIN.readlines.join
246 yaml = YAML.load(input)
247
248 if host_run = yaml['host_run']
249 params = yaml['params'] || {}
250 host_run.each do |run|
251 params.each do |k,v|
252 run = run.gsub("$#{k}", v)
253 end
254 STDOUT.write "#{run}--SEP--"
255 end
256 end
257RUBY
258
e02c1511 259 host_run=`cat $config_file | $docker_path run $user_args --rm -i -a stdout -a stdin $image ruby -e "$env_ruby"`
60f9f04c
S
260
261 while [ "$host_run" ] ; do
262 iter=${host_run%%--SEP--*}
263 echo
264 echo "Host run: $iter"
265 $iter || exit 1
266 echo
267 host_run="${host_run#*--SEP--}"
268 done
269}
270
271
d90671f3 272set_volumes() {
e02c1511 273 volumes=`cat $config_file | $docker_path run $user_args --rm -i -a stdout -a stdin $image ruby -e \
02d9a654 274 "require 'yaml'; puts YAML.load(STDIN.readlines.join)['volumes'].map{|v| '-v ' << v['volume']['host'] << ':' << v['volume']['guest'] << ' '}.join"`
d90671f3
SS
275}
276
41daa523 277set_links() {
e02c1511 278 links=`cat $config_file | $docker_path run $user_args --rm -i -a stdout -a stdin $image ruby -e \
41daa523 279 "require 'yaml'; puts YAML.load(STDIN.readlines.join)['links'].map{|l| '--link ' << l['link']['name'] << ':' << l['link']['alias'] << ' '}.join"`
280}
281
06310c73
GXT
282find_templates() {
283 local templates=`cat $1 | $docker_path run $user_args --rm -i -a stdin -a stdout $image ruby -e \
7f77c274
SS
284 "require 'yaml'; puts YAML.load(STDIN.readlines.join)['templates']"`
285
06310c73
GXT
286 local arrTemplates=${templates// / }
287
2ec550f7 288 if [ ! -z "$templates" ]; then
06310c73
GXT
289 for template in "${arrTemplates[@]}"
290 do
291 local nested_templates=$(find_templates $template)
292
293 if [ ! -z "$nested_templates" ]; then
294 templates="$templates $nested_templates"
295 fi
296 done
297
298 echo $templates
299 else
300 echo ""
301 fi
302}
303
304set_template_info() {
305 templates=$(find_templates $config_file)
306
7f77c274
SS
307 arrTemplates=(${templates// / })
308 config_data=$(cat $config_file)
309
310 input="hack: true"
311
7f77c274
SS
312 for template in "${arrTemplates[@]}"
313 do
314 [ ! -z $template ] && {
315 input="$input _FILE_SEPERATOR_ $(cat $template)"
316 }
317 done
318
319 # we always want our config file last so it takes priority
320 input="$input _FILE_SEPERATOR_ $config_data"
321
322 read -r -d '' env_ruby << 'RUBY'
323 require 'yaml'
324
325 input=STDIN.readlines.join
093e6628 326 # default to UTF-8 for the dbs sake
3cb3d9c4 327 env = {'LANG' => 'en_US.UTF-8'}
7f77c274
SS
328 input.split('_FILE_SEPERATOR_').each do |yml|
329 yml.strip!
330 begin
331 env.merge!(YAML.load(yml)['env'] || {})
f3824347 332 rescue Psych::SyntaxError => e
333 puts e
334 puts "*ERROR."
7f77c274
SS
335 rescue => e
336 puts yml
337 p e
338 end
339 end
0138494b 340 puts env.map{|k,v| "-e\n#{k}=#{v}" }.join("\n")
7f77c274
SS
341RUBY
342
fb827907
EP
343 tmp_input_file=$(mktemp)
344
345 echo "$input" > "$tmp_input_file"
346 raw=`exec cat "$tmp_input_file" | $docker_path run $user_args --rm -i -a stdin -a stdout $image ruby -e "$env_ruby"`
347
348 rm -f "$tmp_input_file"
4b563ee8
SS
349
350 env=()
f3824347 351 ok=1
4b563ee8 352 while read i; do
f3824347 353 if [ "$i" == "*ERROR." ]; then
354 ok=0
355 elif [ -n "$i" ]; then
0138494b 356 env[${#env[@]}]="${i//\{\{config\}\}/${config}}"
16f2d250 357 fi
4b563ee8
SS
358 done <<< "$raw"
359
f3824347 360 if [ "$ok" -ne 1 ]; then
361 echo "${env[@]}"
c2d3ee4a 362 echo "YAML syntax error. Please check your containers/*.yml config files."
f3824347 363 exit 1
364 fi
762d9bbf 365
8f57aae5 366 # labels
762d9bbf
MP
367 read -r -d '' labels_ruby << 'RUBY'
368 require 'yaml'
369
370 input=STDIN.readlines.join
762d9bbf
MP
371 labels = {}
372 input.split('_FILE_SEPERATOR_').each do |yml|
373 yml.strip!
374 begin
375 labels.merge!(YAML.load(yml)['labels'] || {})
376 rescue Psych::SyntaxError => e
377 puts e
378 puts "*ERROR."
379 rescue => e
380 puts yml
381 p e
382 end
383 end
384 puts labels.map{|k,v| "-l\n#{k}=#{v}" }.join("\n")
385RUBY
386
fb827907
EP
387 tmp_input_file=$(mktemp)
388
389 echo "$input" > "$tmp_input_file"
390 raw=`exec cat "$tmp_input_file" | $docker_path run $user_args --rm -i -a stdin -a stdout $image ruby -e "$labels_ruby"`
391
392 rm -f "$tmp_input_file"
762d9bbf
MP
393
394 labels=()
395 ok=1
396 while read i; do
397 if [ "$i" == "*ERROR." ]; then
398 ok=0
399 elif [ -n "$i" ]; then
daddbf86 400 labels[${#labels[@]}]=$(echo $i | sed s/{{config}}/${config}/g)
762d9bbf
MP
401 fi
402 done <<< "$raw"
403
404 if [ "$ok" -ne 1 ]; then
405 echo "${labels[@]}"
406 echo "YAML syntax error. Please check your containers/*.yml config files."
407 exit 1
408 fi
8f57aae5
NL
409
410 # expose
411 read -r -d '' ports_ruby << 'RUBY'
412 require 'yaml'
413
414 input=STDIN.readlines.join
415 ports = []
416 input.split('_FILE_SEPERATOR_').each do |yml|
417 yml.strip!
418 begin
419 ports += (YAML.load(yml)['expose'] || [])
420 rescue Psych::SyntaxError => e
421 puts e
422 puts "*ERROR."
423 rescue => e
424 puts yml
425 p e
426 end
427 end
16fb17cf 428 puts ports.map { |p| p.to_s.include?(':') ? "-p\n#{p}" : "--expose\n#{p}" }.join("\n")
8f57aae5
NL
429RUBY
430
431 tmp_input_file=$(mktemp)
432
433 echo "$input" > "$tmp_input_file"
434 raw=`exec cat "$tmp_input_file" | $docker_path run $user_args --rm -i -a stdin -a stdout $image ruby -e "$ports_ruby"`
435
436 rm -f "$tmp_input_file"
437
438 ports=()
439 ok=1
440 while read i; do
441 if [ "$i" == "*ERROR." ]; then
442 ok=0
443 elif [ -n "$i" ]; then
444 ports[${#ports[@]}]=$i
445 fi
446 done <<< "$raw"
447
448 if [ "$ok" -ne 1 ]; then
449 echo "${ports[@]}"
450 echo "YAML syntax error. Please check your containers/*.yml config files."
451 exit 1
452 fi
bfc79e77
DE
453
454 merge_user_args
7f77c274
SS
455}
456
665468eb 457if [ -z $docker_path ]; then
52388b87 458 install_docker
665468eb 459fi
52388b87 460
de869404 461[ "$command" == "cleanup" ] && {
fa9acf1a 462 $docker_path system prune -a
2dfd2c6d
GXT
463
464 if [ -d /var/discourse/shared/standalone/postgres_data_old ]; then
465 echo
466 echo "Old PostgreSQL backup data cluster detected taking up $(du -hs /var/discourse/shared/standalone/postgres_data_old | awk '{print $1}') detected"
467 read -p "Would you like to remove it? (Y/n): " -n 1 -r && echo
468
469 if [[ $REPLY =~ ^[Yy]$ ]]; then
470 echo "removing old PostgreSQL data cluster at /var/discourse/shared/standalone/postgres_data_old..."
471 rm -rf /var/discourse/shared/standalone/postgres_data_old
472 else
473 exit 1
474 fi
475 fi
476
a8b66f98
L
477 exit 0
478}
5f803fb4 479
65573a0e
GXT
480if [ ! "$command" == "setup" ]; then
481 if [[ ! -e $config_file ]]; then
7e738616 482 echo "Config file was not found, ensure $config_file exists"
5dfdf9a3 483 echo
71680b16 484 echo "Available configs ( `cd containers && ls -dm *.yml | tr -s '\n' ' ' | awk '{ gsub(/\.yml/, ""); print }'`)"
7e738616 485 exit 1
65573a0e 486 fi
7e738616
S
487fi
488
e2ed1fb6
S
489docker_version=($($docker_path --version))
490docker_version=${test[2]//,/}
69545efd 491restart_policy=${restart_policy:---restart=always}
e2ed1fb6 492
30835a52 493set_existing_container(){
295e8f19 494 existing=`$docker_path ps -a | awk '{ print $1, $(NF) }' | grep " $config$" | awk '{ print $1 }'`
337a89aa
S
495}
496
665468eb 497run_stop() {
337a89aa 498
30835a52 499 set_existing_container
60f9f04c 500
30835a52 501 if [ ! -z $existing ]
337a89aa 502 then
30835a52
S
503 (
504 set -x
a9cba0fc 505 $docker_path stop -t 10 $config
30835a52 506 )
337a89aa 507 else
30835a52
S
508 echo "$config was not started !"
509 exit 1
510 fi
511}
337a89aa 512
8877f99e
S
513set_run_image() {
514 run_image=`cat $config_file | $docker_path run $user_args --rm -i -a stdin -a stdout $image ruby -e \
515 "require 'yaml'; puts YAML.load(STDIN.readlines.join)['run_image']"`
516
c786ffcd
GXT
517 if [ -n "$user_run_image" ]; then
518 run_image=$user_run_image
519 elif [ -z "$run_image" ]; then
8877f99e
S
520 run_image="$local_discourse/$config"
521 fi
522}
523
524set_boot_command() {
525 boot_command=`cat $config_file | $docker_path run $user_args --rm -i -a stdin -a stdout $image ruby -e \
526 "require 'yaml'; puts YAML.load(STDIN.readlines.join)['boot_command']"`
527
528 if [ -z "$boot_command" ]; then
529
530 no_boot_command=`cat $config_file | $docker_path run $user_args --rm -i -a stdin -a stdout $image ruby -e \
531 "require 'yaml'; puts YAML.load(STDIN.readlines.join)['no_boot_command']"`
532
533 if [ -z "$no_boot_command" ]; then
534 boot_command="/sbin/boot"
535 fi
536 fi
537}
538
bfc79e77
DE
539merge_user_args() {
540 local docker_args
541
542 docker_args=`cat $config_file | $docker_path run $user_args --rm -i -a stdout -a stdin $image ruby -e \
543 "require 'yaml'; puts YAML.load(STDIN.readlines.join)['docker_args']"`
544
545 if [[ -n "$docker_args" ]]; then
546 user_args="$user_args $docker_args"
547 fi
548}
549
665468eb 550run_start() {
337a89aa 551
295e8f19
S
552 existing=`$docker_path ps | awk '{ print $1, $(NF) }' | grep " $config$" | awk '{ print $1 }'`
553 echo $existing
30835a52
S
554 if [ ! -z $existing ]
555 then
556 echo "Nothing to do, your container has already started!"
eac33309 557 exit 0
30835a52
S
558 fi
559
295e8f19 560 existing=`$docker_path ps -a | awk '{ print $1, $(NF) }' | grep " $config$" | awk '{ print $1 }'`
30835a52
S
561 if [ ! -z $existing ]
562 then
563 echo "starting up existing container"
564 (
565 set -x
566 $docker_path start $config
567 )
568 exit 0
569 fi
570
571 host_run
1f656469 572
30835a52
S
573 set_template_info
574 set_volumes
575 set_links
8877f99e
S
576 set_run_image
577 set_boot_command
30835a52 578
c6dd6f9d
FB
579 # get hostname and settings from container configuration
580 for envar in "${env[@]}"
581 do
582 if [[ $envar == DOCKER_USE_HOSTNAME* ]] || [[ $envar == DISCOURSE_HOSTNAME* ]]
583 then
584 # use as environment variable
585 eval $envar
586 fi
587 done
588
30835a52 589 (
c834fdd1 590 hostname=`hostname -s`
c6dd6f9d
FB
591 # overwrite hostname
592 if [ "$DOCKER_USE_HOSTNAME" = "true" ]
593 then
594 hostname=$DISCOURSE_HOSTNAME
595 else
596 hostname=$hostname-$config
597 fi
598
a0606001
S
599 # we got to normalize so we only have allowed strings, this is more comprehensive but lets see how bash does first
600 # hostname=`$docker_path run $user_args --rm $image ruby -e 'print ARGV[0].gsub(/[^a-zA-Z-]/, "-")' $hostname`
601 # docker added more hostname rules
fd2e7637 602 hostname=${hostname//_/-}
a0606001 603
cad2919f
GXT
604
605 if [ -z "$SKIP_MAC_ADDRESS" ] ; then
606 mac_address="--mac-address $($docker_path run $user_args -i --rm -a stdout -a stderr $image /bin/sh -c "echo $hostname | md5sum | sed 's/^\(..\)\(..\)\(..\)\(..\)\(..\).*$/02:\1:\2:\3:\4:\5/'")"
607 fi
d2a86ee1 608
30835a52 609 set -x
27c21012 610 $docker_path run --shm-size=512m $links $attach_on_run $restart_policy "${env[@]}" "${labels[@]}" -h "$hostname" \
bfc79e77 611 -e DOCKER_HOST_IP="$docker_ip" --name $config -t "${ports[@]}" $volumes $mac_address $user_args \
d2a86ee1 612 $run_image $boot_command
30835a52
S
613
614 )
615 exit 0
337a89aa
S
616
617}
618
2791af60
GXT
619run_run() {
620 set_template_info
621 set_volumes
622 set_links
623 set_run_image
624
625 unset ERR
626 (exec $docker_path run --rm --shm-size=512m $user_args $links "${env[@]}" -e DOCKER_HOST_IP="$docker_ip" -i -a stdin -a stdout -a stderr $volumes $run_image \
627 /bin/bash -c "$run_command") || ERR=$?
628
629 if [[ $ERR > 0 ]]; then
630 exit 1
631 fi
632}
633
634run_bootstrap() {
60f9f04c
S
635 host_run
636
680dd4ea
S
637 # Is the image available?
638 # If not, pull it here so the user is aware what's happening.
4807b1b8 639 $docker_path history $image >/dev/null 2>&1 || $docker_path pull $image
88126eba 640
680dd4ea 641 set_template_info
93149421 642
e02c1511 643 base_image=`cat $config_file | $docker_path run $user_args --rm -i -a stdin -a stdout $image ruby -e \
680dd4ea 644 "require 'yaml'; puts YAML.load(STDIN.readlines.join)['base_image']"`
93149421 645
e02c1511 646 update_pups=`cat $config_file | $docker_path run $user_args --rm -i -a stdin -a stdout $image ruby -e \
680dd4ea 647 "require 'yaml'; puts YAML.load(STDIN.readlines.join)['update_pups']"`
b9c7b50e 648
680dd4ea
S
649 if [[ ! X"" = X"$base_image" ]]; then
650 image=$base_image
651 fi
b9c7b50e 652
680dd4ea 653 set_volumes
41daa523 654 set_links
f126bcc6 655
680dd4ea 656 rm -f $cidbootstrap
d90671f3 657
680dd4ea
S
658 run_command="cd /pups &&"
659 if [[ ! "false" = $update_pups ]]; then
660 run_command="$run_command git pull &&"
661 fi
ca2ce907 662 run_command="$run_command /pups/bin/pups --stdin"
2162f1d4 663
680dd4ea 664 echo $run_command
b9c7b50e 665
b4ab14c2 666 unset ERR
fb827907
EP
667
668 tmp_input_file=$(mktemp)
669
670 echo "$input" > "$tmp_input_file"
671 (exec cat "$tmp_input_file" | $docker_path run --shm-size=512m $user_args $links "${env[@]}" -e DOCKER_HOST_IP="$docker_ip" --cidfile $cidbootstrap -i -a stdin -a stdout -a stderr $volumes $image \
b4ab14c2
S
672 /bin/bash -c "$run_command") || ERR=$?
673
fb827907
EP
674 rm -f "$tmp_input_file"
675
b4ab14c2
S
676 unset FAILED
677 # magic exit code that indicates a retry
678 if [[ "$ERR" == 77 ]]; then
382c8e40
S
679 $docker_path rm `cat $cidbootstrap`
680 rm $cidbootstrap
b4ab14c2 681 exit 77
382c8e40 682 elif [[ "$ERR" > 0 ]]; then
b4ab14c2
S
683 FAILED=TRUE
684 fi
19e3a6c0
S
685
686 if [[ $FAILED = "TRUE" ]]; then
687 if [[ ! -z "$DEBUG" ]]; then
688 $docker_path commit `cat $cidbootstrap` $local_discourse/$config-debug || echo 'FAILED TO COMMIT'
689 echo "** DEBUG ** Maintaining image for diagnostics $local_discourse/$config-debug"
690 fi
88126eba 691
19e3a6c0
S
692 $docker_path rm `cat $cidbootstrap`
693 rm $cidbootstrap
694 echo "** FAILED TO BOOTSTRAP ** please scroll up and look for earlier error messages, there may be more than one"
695 exit 1
696 fi
9fb5f2d3 697
680dd4ea 698 sleep 5
2162f1d4 699
4807b1b8
MB
700 $docker_path commit `cat $cidbootstrap` $local_discourse/$config || echo 'FAILED TO COMMIT'
701 $docker_path rm `cat $cidbootstrap` && rm $cidbootstrap
680dd4ea 702}
9fb5f2d3 703
680dd4ea
S
704case "$command" in
705 bootstrap)
680dd4ea 706 run_bootstrap
2dd2e330 707 echo "Successfully bootstrapped, to startup use ./launcher start $config"
4b3aebe1 708 exit 0
5f803fb4 709 ;;
1acce9e4 710
1ec142a1
GXT
711 run)
712 run_run
713 exit 0
714 ;;
715
2fc6ff36 716 enter)
0c456e8c 717 exec $docker_path exec -it $config /bin/bash --login
2fc6ff36
S
718 ;;
719
5f803fb4 720 stop)
337a89aa
S
721 run_stop
722 exit 0
5f803fb4 723 ;;
7e738616 724
5f803fb4 725 logs)
7e738616 726
30835a52
S
727 $docker_path logs $config
728 exit 0
5f803fb4 729 ;;
7e738616 730
337a89aa
S
731 restart)
732 run_stop
733 run_start
734 exit 0
735 ;;
80c11be3 736
337a89aa
S
737 start)
738 run_start
739 exit 0
5f803fb4 740 ;;
7e738616 741
680dd4ea 742 rebuild)
4b6456ef 743 if [ "$(git symbolic-ref --short HEAD)" == "master" ]; then
c2d3ee4a 744 echo "Ensuring launcher is up to date"
098533cb
S
745
746 git remote update
747
748 LOCAL=$(git rev-parse @)
749 REMOTE=$(git rev-parse @{u})
750 BASE=$(git merge-base @ @{u})
751
752 if [ $LOCAL = $REMOTE ]; then
c2d3ee4a 753 echo "Launcher is up-to-date"
098533cb
S
754
755 elif [ $LOCAL = $BASE ]; then
c2d3ee4a 756 echo "Updating Launcher"
098533cb 757 git pull || (echo 'failed to update' && exit 1)
88ee2e35 758
8100fab0
PD
759 for (( i=${#BASH_ARGV[@]}-1,j=0; i>=0,j<${#BASH_ARGV[@]}; i--,j++ ))
760 do
761 args[$j]=${BASH_ARGV[$i]}
762 done
763 exec /bin/bash $0 "${args[@]}" # $@ is empty, because of shift at the beginning. Use BASH_ARGV instead.
098533cb
S
764
765 elif [ $REMOTE = $BASE ]; then
c2d3ee4a 766 echo "Your version of Launcher is ahead of origin"
098533cb
S
767
768 else
c2d3ee4a 769 echo "Launcher has diverged source, this is only expected in Dev mode"
098533cb
S
770 fi
771
4b6456ef 772 fi
30835a52
S
773
774 set_existing_container
775
776 if [ ! -z $existing ]
680dd4ea
S
777 then
778 echo "Stopping old container"
30835a52
S
779 (
780 set -x
781 $docker_path stop -t 10 $config
782 )
680dd4ea
S
783 fi
784
785 run_bootstrap
786
30835a52 787 if [ ! -z $existing ]
680dd4ea 788 then
30835a52
S
789 echo "Removing old container"
790 (
791 set -x
792 $docker_path rm $config
793 )
680dd4ea
S
794 fi
795
796 run_start
797 exit 0
798 ;;
799
7e738616 800
5f803fb4 801 destroy)
98bd0edf 802 (set -x; $docker_path stop -t 10 $config && $docker_path rm $config) || (echo "$config was not found" && exit 0)
30835a52 803 exit 0
5f803fb4
SS
804 ;;
805esac
7e738616 806
5f803fb4 807usage